/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecoresession
#define headerfilecoresession

#include <ctime>
#include "requesttypes.h"
#include "error.h"
#include "item.h"
#include "done.h"
#include "user.h"



struct Session
{
	// 0 - means that there is no session
	long id;	
	int time;
	
	bool is_logged;
	
	// !! moze tutaj -1 kiedy nie zalogowany i wywalic is_logged?
	long user_id; // logged user

	// !! moze wywalic user_id i zostawic tylko to? kiedy nie zalogowany to bedzie tutaj 0
	User * puser;

	// what is done
	Done done;
	Error done_status;
	
	int done_timer;


	// used for many purposes, depending on 'done'
	Item item;


	// -------------------

	Session();
	virtual void Clear();
	bool operator==(const Session & s) const;
	bool operator<(const Session & s) const;
	bool DecTimer(int & timer);
	void CheckTimers();
};









#endif

